; sum-matrix-rows is a function that sums up lines of matrix and
; returns a list corresponding to that sum.

(define (sum-up-iter value xs) 
    (if (null? xs) value (sum-up-iter (+ value (car xs)) (cdr xs)))) 

(define (sum-up xs) (sum-up-iter 0 xs))

(define (matrix-car mtx)
    (if (null? mtx) '() (cons (car (car mtx)) (matrix-car (cdr mtx)))))   

(define (matrix-cdr mtx)
    (if (null? mtx) '() (cons (cdr (car mtx)) (matrix-cdr (cdr mtx)))))

(define (mtx-null? mtx) 
    (if (null? mtx) #t (and (null? (car mtx)) (mtx-null? (cdr mtx)))))


(define (sum-matrix-rows-iter value mtx)
    (if (mtx-null? mtx) value (sum-matrix-rows-iter (cons (sum-up (matrix-car mtx)) value) (matrix-cdr mtx))))

(define (sum-matrix-rows mtx) (sum-matrix-rows-iter '() mtx))

(display (sum-matrix-rows '((1 1 1) (1 1 1) (2 2 2) (2 2 2))))





