
class LinkedList(object):
    def __init__(self, value, back=None):
        self.value = value
        self.back = back
    def __str__(self):
        data = '('
        point = self        
        while point:
            data = '%s %s' % (data, point.value)
            point = point.back
        data = data + ')'
        return data

class Nil(LinkedList):
    def __init__(self):
        LinkedList.__init__(self, '', None)
    def __str__(self):
        return ''

def cons(xs, ns):
    sl = LinkedList(xs, ns)
    return sl

def sons(xs, value):
    if isinstance(xs, Nil):
        ns = LinkedList(value, xs)
        return ns
    while not isinstance(xs.back, Nil):
        xs = xs.back
    ns = LinkedList(value, xs.back)
    xs.back = ns
    return ns

def cp(xs):
    if isinstance(xs, Nil):
        head = Nil()
        last = head
        return head, last
    head = sons(Nil(), xs.value)
    last = head
    xs = xs.back
    while not isinstance(xs, Nil):
        last = sons(last, xs.value)
        xs = xs.back
    return head, last

def length(xs):
    c = 0
    while not isinstance(xs, Nil):
        c = c + 1
        xs = xs.back
    return c

def append(xs, ns):
    if isinstance(xs, Nil) and not isinstance(ns, Nil):
        return cp(ns)[0]
    elif isinstance(xs, Nil):
        return Nil()
    elif isinstance(ns, Nil):
        return cp(xs)[0]

    head, last = cp(xs)
    while not isinstance(ns, Nil):
        last = sons(last, ns.value)
        ns = ns.back
    return head





