from node import *
from scan import *
from token import *
from traceback import print_exc as debug
from sys import stdin

def execute(filename):
    fd = open(filename, 'r')
    source = fd.read()
    fd.close()

    seq = scan.scan(source)
    sexp = scan.acc(seq, [])
    sexp(GLOBAL_SCOPE)

def evaluate(source):
    scope = GLOBAL_SCOPE.copy()
    seq  = scan(source)
    sexp = acc(seq, [])
    sexp(scope)

def prompt(style=':'):
    count = 0

    while 1:
        source = stdin.readline()

        for ind in scan(source):
            yield ind

        count = count + source.count('(')
        count = count - source.count(')')
        
        if not count:
            raise StopIteration

def interpreter():
    while 1:
        sexp = acc(prompt(), [])
        try:
            sexp(GLOBAL_SCOPE)
        except:
            debug()

